



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>hadoop中MapReduce多种join实现实例分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">hadoop中MapReduce多种join实现实例分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 01:47:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转载自:http://zengzhaozheng.blog.51cto.com/8219051/1392961</p>
<div><strong>1、在Reudce端进行连接。</strong></div>
<div>在Reudce端进行连接是MapReduce框架进行表之间join操作最为常见的模式，其具体的实现原理如下：</div>
<div>Map端的主要工作：为来自不同表（文件）的key/value对打标签以区别不同来源的记录。然后用连接字段作为key，其余部分和新加的标志作为value，最后进行输出。</div>
<div>reduce端的主要工作：在reduce端以连接字段作为key的分组已经完成，我们只需要在每一个分组当中将那些来源于不同文件的记录（在map阶段已经打标志）分开，最后进行笛卡尔只就ok了。原理非常简单，下面来看一个实例：</div>
<div>(1)自定义一个value返回类型:</div>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">package com.mr.reduceSizeJoin;<br />
import java.io.DataInput;<br />
import java.io.DataOutput;<br />
import java.io.IOException;<br />
import org.apache.hadoop.io.Text;<br />
import org.apache.hadoop.io.WritableComparable;<br />
public class CombineValues implements WritableComparable{<br />
    //private static final Logger logger = LoggerFactory.getLogger(CombineValues.class);<br />
    private Text joinKey;//链接关键字<br />
    private Text flag;//文件来源标志<br />
    private Text secondPart;//除了链接键外的其他部分<br />
    public void setJoinKey(Text joinKey) {<br />
        this.joinKey = joinKey;<br />
    }<br />
    public void setFlag(Text flag) {<br />
        this.flag = flag;<br />
    }<br />
    public void setSecondPart(Text secondPart) {<br />
        this.secondPart = secondPart;<br />
    }<br />
    public Text getFlag() {<br />
        return flag;<br />
    }<br />
    public Text getSecondPart() {<br />
        return secondPart;<br />
    }<br />
    public Text getJoinKey() {<br />
        return joinKey;<br />
    }<br />
    public CombineValues() {<br />
        this.joinKey =  new Text();<br />
        this.flag = new Text();<br />
        this.secondPart = new Text();<br />
    }

    @Override<br />
    public void write(DataOutput out) throws IOException {<br />
        this.joinKey.write(out);<br />
        this.flag.write(out);<br />
        this.secondPart.write(out);<br />
    }<br />
    @Override<br />
    public void readFields(DataInput in) throws IOException {<br />
        this.joinKey.readFields(in);<br />
        this.flag.readFields(in);<br />
        this.secondPart.readFields(in);<br />
    }<br />
    @Override<br />
    public int compareTo(CombineValues o) {<br />
        return this.joinKey.compareTo(o.getJoinKey());<br />
    }<br />
    @Override<br />
    public String toString() {<br />
        // TODO Auto-generated method stub<br />
        return "[flag="+this.flag.toString()+",joinKey="+this.joinKey.toString()+",secondPart="+this.secondPart.toString()+"]";<br />
    }<br />
}</pre>
</div>
</div>
<p>(2)map、reduce主体代码</p>
<div>
<div>
<pre class="prettyprint linenums">package com.mr.reduceSizeJoin;<br />
import java.io.IOException;<br />
import java.util.ArrayList;<br />
import org.apache.hadoop.conf.Configuration;<br />
import org.apache.hadoop.conf.Configured;<br />
import org.apache.hadoop.fs.Path;<br />
import org.apache.hadoop.io.Text;<br />
import org.apache.hadoop.mapreduce.Job;<br />
import org.apache.hadoop.mapreduce.Mapper;<br />
import org.apache.hadoop.mapreduce.Reducer;<br />
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.input.FileSplit;<br />
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;<br />
import org.apache.hadoop.util.Tool;<br />
import org.apache.hadoop.util.ToolRunner;<br />
import org.slf4j.Logger;<br />
import org.slf4j.LoggerFactory;<br />
/**<br />
* @author zengzhaozheng<br />
* 用途说明：<br />
* reudce side join中的left outer join<br />
* 左连接，两个文件分别代表2个表,连接字段table1的id字段和table2的cityID字段<br />
* table1(左表):tb_dim_city(id int,name string,orderid int,city_code,is_show)<br />
* tb_dim_city.dat文件内容,分隔符为"|"：<br />
* id     name  orderid  city_code  is_show<br />
* 0       其他        9999     9999         0<br />
* 1       长春        1        901          1<br />
* 2       吉林        2        902          1<br />
* 3       四平        3        903          1<br />
* 4       松原        4        904          1<br />
* 5       通化        5        905          1<br />
* 6       辽源        6        906          1<br />
* 7       白城        7        907          1<br />
* 8       白山        8        908          1<br />
* 9       延吉        9        909          1<br />
* -------------------------风骚的分割线-------------------------------<br />
* table2(右表)：tb_user_profiles(userID int,userName string,network string,double flow,cityID int)<br />
* tb_user_profiles.dat文件内容,分隔符为"|"：<br />
* userID   network     flow    cityID<br />
* 1           2G       123      1<br />
* 2           3G       333      2<br />
* 3           3G       555      1<br />
* 4           2G       777      3<br />
* 5           3G       666      4<br />
*<br />
* -------------------------风骚的分割线-------------------------------<br />
*  结果：<br />
*  1   长春  1   901 1   1   2G  123<br />
*  1   长春  1   901 1   3   3G  555<br />
*  2   吉林  2   902 1   2   3G  333<br />
*  3   四平  3   903 1   4   2G  777<br />
*  4   松原  4   904 1   5   3G  666<br />
*/<br />
public class ReduceSideJoin_LeftOuterJoin extends Configured implements Tool{<br />
    private static final Logger logger = LoggerFactory.getLogger(ReduceSideJoin_LeftOuterJoin.class);<br />
    public static class LeftOutJoinMapper extends Mapper {<br />
        private CombineValues combineValues = new CombineValues();<br />
        private Text flag = new Text();<br />
        private Text joinKey = new Text();<br />
        private Text secondPart = new Text();<br />
        @Override<br />
        protected void map(Object key, Text value, Context context)<br />
                throws IOException, InterruptedException {<br />
            //获得文件输入路径<br />
            String pathName = ((FileSplit) context.getInputSplit()).getPath().toString();<br />
            //数据来自tb_dim_city.dat文件,标志即为"0"<br />
            if(pathName.endsWith("tb_dim_city.dat")){<br />
                String[] valueItems = value.toString().split("\\|");<br />
                //过滤格式错误的记录<br />
                if(valueItems.length != 5){<br />
                    return;<br />
                }<br />
                flag.set("0");<br />
                joinKey.set(valueItems[0]);<br />
                secondPart.set(valueItems[1]+"\t"+valueItems[2]+"\t"+valueItems[3]+"\t"+valueItems[4]);<br />
                combineValues.setFlag(flag);<br />
                combineValues.setJoinKey(joinKey);<br />
                combineValues.setSecondPart(secondPart);<br />
                context.write(combineValues.getJoinKey(), combineValues);

                }//数据来自于tb_user_profiles.dat，标志即为"1"<br />
            else if(pathName.endsWith("tb_user_profiles.dat")){<br />
                String[] valueItems = value.toString().split("\\|");<br />
                //过滤格式错误的记录<br />
                if(valueItems.length != 4){<br />
                    return;<br />
                }<br />
                flag.set("1");<br />
                joinKey.set(valueItems[3]);<br />
                secondPart.set(valueItems[0]+"\t"+valueItems[1]+"\t"+valueItems[2]);<br />
                combineValues.setFlag(flag);<br />
                combineValues.setJoinKey(joinKey);<br />
                combineValues.setSecondPart(secondPart);<br />
                context.write(combineValues.getJoinKey(), combineValues);<br />
            }<br />
        }<br />
    }<br />
    public static class LeftOutJoinReducer extends Reducer {<br />
        //存储一个分组中的左表信息<br />
        private ArrayList leftTable = new ArrayList();<br />
        //存储一个分组中的右表信息<br />
        private ArrayList rightTable = new ArrayList();<br />
        private Text secondPar = null;<br />
        private Text output = new Text();<br />
        /**<br />
         * 一个分组调用一次reduce函数<br />
         */<br />
        @Override<br />
        protected void reduce(Text key, Iterable value, Context context)<br />
                throws IOException, InterruptedException {<br />
            leftTable.clear();<br />
            rightTable.clear();<br />
            /**<br />
             * 将分组中的元素按照文件分别进行存放<br />
             * 这种方法要注意的问题：<br />
             * 如果一个分组内的元素太多的话，可能会导致在reduce阶段出现OOM，<br />
             * 在处理分布式问题之前最好先了解数据的分布情况，根据不同的分布采取最<br />
             * 适当的处理方法，这样可以有效的防止导致OOM和数据过度倾斜问题。<br />
             */<br />
            for(CombineValues cv : value){<br />
                secondPar = new Text(cv.getSecondPart().toString());<br />
                //左表tb_dim_city<br />
                if("0".equals(cv.getFlag().toString().trim())){<br />
                    leftTable.add(secondPar);<br />
                }<br />
                //右表tb_user_profiles<br />
                else if("1".equals(cv.getFlag().toString().trim())){<br />
                    rightTable.add(secondPar);<br />
                }<br />
            }<br />
            logger.info("tb_dim_city:"+leftTable.toString());<br />
            logger.info("tb_user_profiles:"+rightTable.toString());<br />
            for(Text leftPart : leftTable){<br />
                for(Text rightPart : rightTable){<br />
                    output.set(leftPart+ "\t" + rightPart);<br />
                    context.write(key, output);<br />
                }<br />
            }<br />
        }<br />
    }<br />
    @Override<br />
    public int run(String[] args) throws Exception {<br />
          Configuration conf=getConf(); //获得配置文件对象<br />
            Job job=new Job(conf,"LeftOutJoinMR");<br />
            job.setJarByClass(ReduceSideJoin_LeftOuterJoin.class);<br />
            FileInputFormat.addInputPath(job, new Path(args[0])); //设置map输入文件路径<br />
            FileOutputFormat.setOutputPath(job, new Path(args[1])); //设置reduce输出文件路径<br />
            job.setMapperClass(LeftOutJoinMapper.class);<br />
            job.setReducerClass(LeftOutJoinReducer.class);<br />
            job.setInputFormatClass(TextInputFormat.class); //设置文件输入格式<br />
            job.setOutputFormatClass(TextOutputFormat.class);//使用默认的output格格式

            //设置map的输出key和value类型<br />
            job.setMapOutputKeyClass(Text.class);<br />
            job.setMapOutputValueClass(CombineValues.class);

            //设置reduce的输出key和value类型<br />
            job.setOutputKeyClass(Text.class);<br />
            job.setOutputValueClass(Text.class);<br />
            job.waitForCompletion(true);<br />
            return job.isSuccessful()?0:1;<br />
    }<br />
    public static void main(String[] args) throws IOException,<br />
            ClassNotFoundException, InterruptedException {<br />
        try {<br />
            int returnCode =  ToolRunner.run(new ReduceSideJoin_LeftOuterJoin(),args);<br />
            System.exit(returnCode);<br />
        } catch (Exception e) {<br />
            // TODO Auto-generated catch block<br />
            logger.error(e.getMessage());<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>其中具体的分析以及数据的输出输入请看代码中的注释已经写得比较清楚了，这里主要分析一下reduce join的一些不足。之所以会存在reduce join这种方式，我们可以很明显的看出原：因为整体数据被分割了，每个map task只处理一部分数据而不能够获取到所有需要的join字段，因此我们需要在讲join key作为reduce端的分组将所有join key相同的记录集中起来进行处理，所以reduce join这种方式就出现了。这种方式的缺点很明显就是会造成map和reduce端也就是shuffle阶段出现大量的数据传输，效率很低.</p>
</div>
</div>
<div><strong>2、在Map端进行连接。</strong></div>
<div>使用场景：一张表十分小、一张表很大。</div>
<div>用法:在提交作业的时候先将小表文件放到该作业的DistributedCache中，然后从DistributeCache中取出该小表进行join key / value解释分割放到内存中（可以放大Hash Map等等容器中）。然后扫描大表，看大表中的每条记录的join key /value值是否能够在内存中找到相同join key的记录，如果有则直接输出结果。</div>
<div>直接上代码，比较简单：</div>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">package com.mr.mapSideJoin;<br />
import java.io.BufferedReader;<br />
import java.io.FileReader;<br />
import java.io.IOException;<br />
import java.util.HashMap;<br />
import org.apache.hadoop.conf.Configuration;<br />
import org.apache.hadoop.conf.Configured;<br />
import org.apache.hadoop.filecache.DistributedCache;<br />
import org.apache.hadoop.fs.Path;<br />
import org.apache.hadoop.io.Text;<br />
import org.apache.hadoop.mapreduce.Job;<br />
import org.apache.hadoop.mapreduce.Mapper;<br />
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;<br />
import org.apache.hadoop.util.Tool;<br />
import org.apache.hadoop.util.ToolRunner;<br />
import org.slf4j.Logger;<br />
import org.slf4j.LoggerFactory;<br />
/**<br />
* @author zengzhaozheng<br />
*<br />
* 用途说明：<br />
* Map side join中的left outer join<br />
* 左连接，两个文件分别代表2个表,连接字段table1的id字段和table2的cityID字段<br />
* table1(左表):tb_dim_city(id int,name string,orderid int,city_code,is_show)，<br />
* 假设tb_dim_city文件记录数很少，tb_dim_city.dat文件内容,分隔符为"|"：<br />
* id     name  orderid  city_code  is_show<br />
* 0       其他        9999     9999         0<br />
* 1       长春        1        901          1<br />
* 2       吉林        2        902          1<br />
* 3       四平        3        903          1<br />
* 4       松原        4        904          1<br />
* 5       通化        5        905          1<br />
* 6       辽源        6        906          1<br />
* 7       白城        7        907          1<br />
* 8       白山        8        908          1<br />
* 9       延吉        9        909          1<br />
* -------------------------风骚的分割线-------------------------------<br />
* table2(右表)：tb_user_profiles(userID int,userName string,network string,double flow,cityID int)<br />
* tb_user_profiles.dat文件内容,分隔符为"|"：<br />
* userID   network     flow    cityID<br />
* 1           2G       123      1<br />
* 2           3G       333      2<br />
* 3           3G       555      1<br />
* 4           2G       777      3<br />
* 5           3G       666      4<br />
* -------------------------风骚的分割线-------------------------------<br />
*  结果：<br />
*  1   长春  1   901 1   1   2G  123<br />
*  1   长春  1   901 1   3   3G  555<br />
*  2   吉林  2   902 1   2   3G  333<br />
*  3   四平  3   903 1   4   2G  777<br />
*  4   松原  4   904 1   5   3G  666<br />
*/<br />
public class MapSideJoinMain extends Configured implements Tool{<br />
    private static final Logger logger = LoggerFactory.getLogger(MapSideJoinMain.class);<br />
    public static class LeftOutJoinMapper extends Mapper {

        private HashMap city_info = new HashMap();<br />
        private Text outPutKey = new Text();<br />
        private Text outPutValue = new Text();<br />
        private String mapInputStr = null;<br />
        private String mapInputSpit[] = null;<br />
        private String city_secondPart = null;<br />
        /**<br />
         * 此方法在每个task开始之前执行，这里主要用作从DistributedCache<br />
         * 中取到tb_dim_city文件，并将里边记录取出放到内存中。<br />
         */<br />
        @Override<br />
        protected void setup(Context context)<br />
                throws IOException, InterruptedException {<br />
            BufferedReader br = null;<br />
            //获得当前作业的DistributedCache相关文件<br />
            Path[] distributePaths = DistributedCache.getLocalCacheFiles(context.getConfiguration());<br />
            String cityInfo = null;<br />
            for(Path p : distributePaths){<br />
                if(p.toString().endsWith("tb_dim_city.dat")){<br />
                    //读缓存文件，并放到mem中<br />
                    br = new BufferedReader(new FileReader(p.toString()));<br />
                    while(null!=(cityInfo=br.readLine())){<br />
                        String[] cityPart = cityInfo.split("\\|",5);<br />
                        if(cityPart.length ==5){<br />
                            city_info.put(cityPart[0], cityPart[1]+"\t"+cityPart[2]+"\t"+cityPart[3]+"\t"+cityPart[4]);<br />
                        }<br />
                    }<br />
                }<br />
            }<br />
        }

        /**<br />
         * Map端的实现相当简单，直接判断tb_user_profiles.dat中的<br />
         * cityID是否存在我的map中就ok了，这样就可以实现Map Join了<br />
         */<br />
        @Override<br />
        protected void map(Object key, Text value, Context context)<br />
                throws IOException, InterruptedException {<br />
            //排掉空行<br />
            if(value == null || value.toString().equals("")){<br />
                return;<br />
            }<br />
            mapInputStr = value.toString();<br />
            mapInputSpit = mapInputStr.split("\\|",4);<br />
            //过滤非法记录<br />
            if(mapInputSpit.length != 4){<br />
                return;<br />
            }<br />
            //判断链接字段是否在map中存在<br />
            city_secondPart = city_info.get(mapInputSpit[3]);<br />
            if(city_secondPart != null){<br />
                this.outPutKey.set(mapInputSpit[3]);<br />
                this.outPutValue.set(city_secondPart+"\t"+mapInputSpit[0]+"\t"+mapInputSpit[1]+"\t"+mapInputSpit[2]);<br />
                context.write(outPutKey, outPutValue);<br />
            }<br />
        }<br />
    }<br />
    @Override<br />
    public int run(String[] args) throws Exception {<br />
            Configuration conf=getConf(); //获得配置文件对象<br />
            DistributedCache.addCacheFile(new Path(args[1]).toUri(), conf);//为该job添加缓存文件<br />
            Job job=new Job(conf,"MapJoinMR");<br />
            job.setNumReduceTasks(0);

            FileInputFormat.addInputPath(job, new Path(args[0])); //设置map输入文件路径<br />
            FileOutputFormat.setOutputPath(job, new Path(args[2])); //设置reduce输出文件路径

            job.setJarByClass(MapSideJoinMain.class);<br />
            job.setMapperClass(LeftOutJoinMapper.class);

            job.setInputFormatClass(TextInputFormat.class); //设置文件输入格式<br />
            job.setOutputFormatClass(TextOutputFormat.class);//使用默认的output格式

            //设置map的输出key和value类型<br />
            job.setMapOutputKeyClass(Text.class);

            //设置reduce的输出key和value类型<br />
            job.setOutputKeyClass(Text.class);<br />
            job.setOutputValueClass(Text.class);<br />
            job.waitForCompletion(true);<br />
            return job.isSuccessful()?0:1;<br />
    }<br />
    public static void main(String[] args) throws IOException,<br />
            ClassNotFoundException, InterruptedException {<br />
        try {<br />
            int returnCode =  ToolRunner.run(new MapSideJoinMain(),args);<br />
            System.exit(returnCode);<br />
        } catch (Exception e) {<br />
            // TODO Auto-generated catch block<br />
            logger.error(e.getMessage());<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
</div>
</div>
<div>这里说说DistributedCache。DistributedCache是分布式缓存的一种实现，它在整个MapReduce框架中起着相当重要的作用，他可以支撑我们写一些相当复杂高效的分布式程序。说回到这里，JobTracker在作业启动之前会获取到DistributedCache的资源uri列表，并将对应的文件分发到各个涉及到该作业的任务的TaskTracker上。另外，关于DistributedCache和作业的关系，比如权限、存储路径区分、public和private等属性，接下来有用再整理研究一下写一篇blog，这里就不详细说了。</div>
<div>另外还有一种比较变态的Map Join方式，就是结合HBase来做Map Join操作。这种方式完全可以突破内存的控制，使你毫无忌惮的使用Map Join，而且效率也非常不错。</div>
<div><strong>3、SemiJoin。</strong></div>
<div>SemiJoin就是所谓的半连接，其实仔细一看就是reduce join的一个变种，就是在map端过滤掉一些数据，在网络中只传输参与连接的数据不参与连接的数据不必在网络中进行传输，从而减少了shuffle的网络传输量，使整体效率得到提高，其他思想和reduce join是一模一样的。说得更加接地气一点就是将小表中参与join的key单独抽出来通过DistributedCach分发到相关节点，然后将其取出放到内存中（可以放到HashSet中），在map阶段扫描连接表，将join key不在内存HashSet中的记录过滤掉，让那些参与join的记录通过shuffle传输到reduce端进行join操作，其他的和reduce join都是一样的。看代码：</div>
<div>
<div>
<div>
<div>
<pre class="prettyprint linenums">package com.mr.SemiJoin;<br />
import java.io.BufferedReader;<br />
import java.io.FileReader;<br />
import java.io.IOException;<br />
import java.util.ArrayList;<br />
import java.util.HashSet;<br />
import org.apache.hadoop.conf.Configuration;<br />
import org.apache.hadoop.conf.Configured;<br />
import org.apache.hadoop.filecache.DistributedCache;<br />
import org.apache.hadoop.fs.Path;<br />
import org.apache.hadoop.io.Text;<br />
import org.apache.hadoop.mapreduce.Job;<br />
import org.apache.hadoop.mapreduce.Mapper;<br />
import org.apache.hadoop.mapreduce.Reducer;<br />
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.input.FileSplit;<br />
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;<br />
import org.apache.hadoop.util.Tool;<br />
import org.apache.hadoop.util.ToolRunner;<br />
import org.slf4j.Logger;<br />
import org.slf4j.LoggerFactory;<br />
/**<br />
* @author zengzhaozheng<br />
*<br />
* 用途说明：<br />
* reudce side join中的left outer join<br />
* 左连接，两个文件分别代表2个表,连接字段table1的id字段和table2的cityID字段<br />
* table1(左表):tb_dim_city(id int,name string,orderid int,city_code,is_show)<br />
* tb_dim_city.dat文件内容,分隔符为"|"：<br />
* id     name  orderid  city_code  is_show<br />
* 0       其他        9999     9999         0<br />
* 1       长春        1        901          1<br />
* 2       吉林        2        902          1<br />
* 3       四平        3        903          1<br />
* 4       松原        4        904          1<br />
* 5       通化        5        905          1<br />
* 6       辽源        6        906          1<br />
* 7       白城        7        907          1<br />
* 8       白山        8        908          1<br />
* 9       延吉        9        909          1<br />
* -------------------------风骚的分割线-------------------------------<br />
* table2(右表)：tb_user_profiles(userID int,userName string,network string,double flow,cityID int)<br />
* tb_user_profiles.dat文件内容,分隔符为"|"：<br />
* userID   network     flow    cityID<br />
* 1           2G       123      1<br />
* 2           3G       333      2<br />
* 3           3G       555      1<br />
* 4           2G       777      3<br />
* 5           3G       666      4<br />
* -------------------------风骚的分割线-------------------------------<br />
* joinKey.dat内容：<br />
* city_code<br />
* 1<br />
* 2<br />
* 3<br />
* 4<br />
* -------------------------风骚的分割线-------------------------------<br />
*  结果：<br />
*  1   长春  1   901 1   1   2G  123<br />
*  1   长春  1   901 1   3   3G  555<br />
*  2   吉林  2   902 1   2   3G  333<br />
*  3   四平  3   903 1   4   2G  777<br />
*  4   松原  4   904 1   5   3G  666<br />
*/<br />
public class SemiJoin extends Configured implements Tool{<br />
    private static final Logger logger = LoggerFactory.getLogger(SemiJoin.class);<br />
    public static class SemiJoinMapper extends Mapper {<br />
        private CombineValues combineValues = new CombineValues();<br />
        private HashSet joinKeySet = new HashSet();<br />
        private Text flag = new Text();<br />
        private Text joinKey = new Text();<br />
        private Text secondPart = new Text();<br />
        /**<br />
         * 将参加join的key从DistributedCache取出放到内存中，以便在map端将要参加join的key过滤出来。b<br />
         */<br />
        @Override<br />
        protected void setup(Context context)<br />
                throws IOException, InterruptedException {<br />
            BufferedReader br = null;<br />
            //获得当前作业的DistributedCache相关文件<br />
            Path[] distributePaths = DistributedCache.getLocalCacheFiles(context.getConfiguration());<br />
            String joinKeyStr = null;<br />
            for(Path p : distributePaths){<br />
                if(p.toString().endsWith("joinKey.dat")){<br />
                    //读缓存文件，并放到mem中<br />
                    br = new BufferedReader(new FileReader(p.toString()));<br />
                    while(null!=(joinKeyStr=br.readLine())){<br />
                        joinKeySet.add(joinKeyStr);<br />
                    }<br />
                }<br />
            }<br />
        }<br />
        @Override<br />
        protected void map(Object key, Text value, Context context)<br />
                throws IOException, InterruptedException {<br />
            //获得文件输入路径<br />
            String pathName = ((FileSplit) context.getInputSplit()).getPath().toString();<br />
            //数据来自tb_dim_city.dat文件,标志即为"0"<br />
            if(pathName.endsWith("tb_dim_city.dat")){<br />
                String[] valueItems = value.toString().split("\\|");<br />
                //过滤格式错误的记录<br />
                if(valueItems.length != 5){<br />
                    return;<br />
                }<br />
                //过滤掉不需要参加join的记录<br />
                if(joinKeySet.contains(valueItems[0])){<br />
                    flag.set("0");<br />
                    joinKey.set(valueItems[0]);<br />
                    secondPart.set(valueItems[1]+"\t"+valueItems[2]+"\t"+valueItems[3]+"\t"+valueItems[4]);<br />
                    combineValues.setFlag(flag);<br />
                    combineValues.setJoinKey(joinKey);<br />
                    combineValues.setSecondPart(secondPart);<br />
                    context.write(combineValues.getJoinKey(), combineValues);<br />
                }else{<br />
                    return ;<br />
                }<br />
            }//数据来自于tb_user_profiles.dat，标志即为"1"<br />
            else if(pathName.endsWith("tb_user_profiles.dat")){<br />
                String[] valueItems = value.toString().split("\\|");<br />
                //过滤格式错误的记录<br />
                if(valueItems.length != 4){<br />
                    return;<br />
                }<br />
                //过滤掉不需要参加join的记录<br />
                if(joinKeySet.contains(valueItems[3])){<br />
                    flag.set("1");<br />
                    joinKey.set(valueItems[3]);<br />
                    secondPart.set(valueItems[0]+"\t"+valueItems[1]+"\t"+valueItems[2]);<br />
                    combineValues.setFlag(flag);<br />
                    combineValues.setJoinKey(joinKey);<br />
                    combineValues.setSecondPart(secondPart);<br />
                    context.write(combineValues.getJoinKey(), combineValues);<br />
                }else{<br />
                    return ;<br />
                }<br />
            }<br />
        }<br />
    }<br />
    public static class SemiJoinReducer extends Reducer {<br />
        //存储一个分组中的左表信息<br />
        private ArrayList leftTable = new ArrayList();<br />
        //存储一个分组中的右表信息<br />
        private ArrayList rightTable = new ArrayList();<br />
        private Text secondPar = null;<br />
        private Text output = new Text();<br />
        /**<br />
         * 一个分组调用一次reduce函数<br />
         */<br />
        @Override<br />
        protected void reduce(Text key, Iterable value, Context context)<br />
                throws IOException, InterruptedException {<br />
            leftTable.clear();<br />
            rightTable.clear();<br />
            /**<br />
             * 将分组中的元素按照文件分别进行存放<br />
             * 这种方法要注意的问题：<br />
             * 如果一个分组内的元素太多的话，可能会导致在reduce阶段出现OOM，<br />
             * 在处理分布式问题之前最好先了解数据的分布情况，根据不同的分布采取最<br />
             * 适当的处理方法，这样可以有效的防止导致OOM和数据过度倾斜问题。<br />
             */<br />
            for(CombineValues cv : value){<br />
                secondPar = new Text(cv.getSecondPart().toString());<br />
                //左表tb_dim_city<br />
                if("0".equals(cv.getFlag().toString().trim())){<br />
                    leftTable.add(secondPar);<br />
                }<br />
                //右表tb_user_profiles<br />
                else if("1".equals(cv.getFlag().toString().trim())){<br />
                    rightTable.add(secondPar);<br />
                }<br />
            }<br />
            logger.info("tb_dim_city:"+leftTable.toString());<br />
            logger.info("tb_user_profiles:"+rightTable.toString());<br />
            for(Text leftPart : leftTable){<br />
                for(Text rightPart : rightTable){<br />
                    output.set(leftPart+ "\t" + rightPart);<br />
                    context.write(key, output);<br />
                }<br />
            }<br />
        }<br />
    }<br />
    @Override<br />
    public int run(String[] args) throws Exception {<br />
            Configuration conf=getConf(); //获得配置文件对象<br />
            DistributedCache.addCacheFile(new Path(args[2]).toUri(), conf);<br />
            Job job=new Job(conf,"LeftOutJoinMR");<br />
            job.setJarByClass(SemiJoin.class);

            FileInputFormat.addInputPath(job, new Path(args[0])); //设置map输入文件路径<br />
            FileOutputFormat.setOutputPath(job, new Path(args[1])); //设置reduce输出文件路径

            job.setMapperClass(SemiJoinMapper.class);<br />
            job.setReducerClass(SemiJoinReducer.class);

            job.setInputFormatClass(TextInputFormat.class); //设置文件输入格式<br />
            job.setOutputFormatClass(TextOutputFormat.class);//使用默认的output格式

            //设置map的输出key和value类型<br />
            job.setMapOutputKeyClass(Text.class);<br />
            job.setMapOutputValueClass(CombineValues.class);

            //设置reduce的输出key和value类型<br />
            job.setOutputKeyClass(Text.class);<br />
            job.setOutputValueClass(Text.class);<br />
            job.waitForCompletion(true);<br />
            return job.isSuccessful()?0:1;<br />
    }<br />
    public static void main(String[] args) throws IOException,<br />
            ClassNotFoundException, InterruptedException {<br />
        try {<br />
            int returnCode =  ToolRunner.run(new SemiJoin(),args);<br />
            System.exit(returnCode);<br />
        } catch (Exception e) {<br />
            logger.error(e.getMessage());<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
</div>
</div>
<div>这里还说说SemiJoin也是有一定的适用范围的，其抽取出来进行join的key是要放到内存中的，所以不能够太大，容易在Map端造成OOM。</div>
<div><strong><br />总结</strong></div>
<div>blog介绍了三种join方式。这三种join方式适用于不同的场景，其处理效率上的相差还是蛮大的，其中主要导致因素是网络传输。Map join效率最高，其次是SemiJoin，最低的是reduce join。另外，写分布式大数据处理程序的时最好要对整体要处理的数据分布情况作一个了解，这可以提高我们代码的效率，使数据的倾斜度降到最低，使我们的代码倾向性更好。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4950yyv8.html">ExtJS 中类的选项 - config</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g3yjlq.html">Zookeeper分布式集群搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gyy1q.html">asp&period;net gridview 鼠标悬浮提示信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx1x6q.html">yii2发送邮件教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jr0pgq.html">web&period;config中customErrors与httpErrors的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqly5o09.html">linux下proc里关于磁盘性能的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7zyxq.html">【bzoj1006】&lbrack;HNOI2008&rsqb;神奇的国度</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5oy48.html">数组Api &period;map&lpar;&rpar;的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vzpj9.html">PYTHON线程知识再研习G--线程间通信Event</a>
		</li>
						<li><a href="https://www.batexi.com/a/950gozm8.html">struts整合spring整合hibernate</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gep41e8.html">selenium2使用记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kpnz59.html">PHP新手之学习类与对象&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pz56n8.html">SSM（Spring&plus;SpringMVC&plus;Mybatis）框架搭建详细教程【附源代码Demo】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y613g8.html">Java版本APP接口安全设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y0pvn8.html">在docker中安装mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/953glr68.html">java环境变量设置与java查看安装路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn24x2q.html">20135234mqy-&mdash;&mdash;信息安全系统设计基础第九周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2km42lq.html">MongoDB（课时17 更新函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkrdl18.html">滑动窗口解决Substring Search Problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ngye9.html">oracle 临时表的使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jv6kg9.html">HTTP基本认证</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1yx46q.html">&lbrack;Asp&period;net 开发系列之SignalR篇&rsqb;专题三：使用SignalR实现聊天室的功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p7od79.html">STC12C5A60S2笔记3（I&sol;O 端口）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy67rd8.html">&lbrack;&period;net 面向对象编程基础&rsqb; &lpar;16&rpar; 接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93344r9.html">浅谈Excel开发：一 Excel 开发概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1y705q.html">JavaScript思维导图&mdash;运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/r933zvw9.html">&lbrack;nRF51822&rsqb; 6、基于nRF51822平台的flash读写研究</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdg22jq.html">如何用django开发一个简易个人Blog</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p7lrd9.html">Hibernate SQL实际sql语句监控- p6spy&plus;hibernate&plus;proxool 设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qng7vk8.html">用CSS实现居中的方式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
